<!DOCTYPE html>
<html lang="es">
<head>
  <?php require_once "./url.php" ?>

  <!-- Metadata & Essential styles and scripts -->
  <?php require_once "./headEssential.php" ?>
</head>
<body>

  <!-- Header -->
  <?php require_once "./header.php" ?>

  <!-- Navbar -->
  <?php require_once "./navbar.php" ?>

  <main class="container py-5">
    <h2 class="h3 border-bottom text-secondary text-center pb-3 mb-3"> Documento firmado</h2>
        <div class="row">
            <div class="col-10 offset-1 col-md-6 offset-md-3">
<?php
session_start();


/**
 * ValidateFiles
 * valida de archivos subidos
 * @param temp  (ruta del archivo temporal)
 * @param route (ruta relativa del archivo subido)
 * @return bool
 *
 * @author Angelo Osorio (@engelpain)
 * @licence CENDITEL 2.0
 */
function ValidateFiles($temp, $route) {
    move_uploaded_file($temp, $route) or die("Error al intentar subir el archivo." . $route);
}

// Datetime
$datetime = date_timestamp_get(date_create());  // nombre que tendrán los archivos temporales cargados

// Frase de paso del p12
$passphase = base64_decode($_POST["password"]); // Frase de paso cifrada
openssl_private_decrypt($passphase, $password, $_SESSION["private_key_pem"]); // Frase de paso decifrada

// PDF
$route_pdf = '../tmp/' . $datetime . '.pdf';       // ruta donde se alojará el pdf
$pdf = $_FILES['pdf']['tmp_name'];                 // ruta del archivo temporal del pdf subido

// PKCS12
$route_pkcs12 = '../tmp/' . $datetime . '.p12';    // Ruta donde se alojará el p12
$pkcs12 = $_FILES['pkcs12']['tmp_name'];        // ruta del archivo temporal del p12 subido

print_r(ValidateFiles($pdf, $route_pdf));
print_r(ValidateFiles($pkcs12, $route_pkcs12));

// Ejecución del script que conecta con el API de PortableSigner

$callPortable = "java -jar ../PortableSigner.jar -n";

$error_log = "../tmp/error_log";
$run_shell = `$callPortable -t $route_pdf -o ../tmp/$datetime-signed.pdf -s $route_pkcs12 -p $password 2> $error_log`;
$run = ($run_shell) ? false : true;

$archivo = fopen ("../tmp/error_log", "r");
$num_lineas = 0;
while (!feof ($archivo)) {
    if ($linea = fgets($archivo)){
       $num_lineas++;
    }
}
fclose($archivo);


if ($run && $num_lineas == 1 ) {
    echo '<a class="btn btn-primary btn-block" href="../tmp/'.$datetime.'-signed.pdf" target="_blank">
                    <i class="fa fa-file-download"></i> Descargar PDF firmado
                </a>';
    session_destroy();
} else {
    echo '<p class="text-center alert-danger text-danger py-4">La constraseña es incorrecta.</p>';
    // En caso de requerir los resultados del log, descomentar
    /*
    $myfile = fopen("../tmp/error_log", "r") or die("Unable to open file!");
    echo fread($myfile, filesize("../tmp/error_log"));
    fclose($myfile);
    */
}

unlink($route_pdf) or die("No se pudo eliminar el pdf");
unlink($route_pkcs12) or die("No se pudo eliminar el p12");

?>
            </div>
            <div class="col-10 offset-1 col-md-6 offset-md-3 pt-3">
                <a class="btn btn-secondary btn-block" href="<?php returnURL(); ?>/">
                    <i class="fa fa-hand-point-left"></i> Volver atrás
                </a>
            </div>
        </div>
  </main>

  <!-- Footer -->
  <?php require_once "./footer.php" ?>
</body>
</html>